#include <string.h>
#include <stdint.h>
#include <stdbool.h>

#include <PontCoopScheduler.h>
#include <stdlib.h>
#include <main.h>
#include <usart.h>

#include <led.h>
#include <loopCtrl.h>
#include <mbusComm.h>


void my_setup_1() {
    schInit();
}

void my_errorHandler() {
    ledRed(true);
}

void helloWorld(void *handle) {
    static char hello[] = "Hello World\n\r";
    HAL_UART_Transmit_IT(&debugUart, (uint8_t*) hello, strlen(hello));
}

void helloMeterbus(void *handle) {
    mbusCommRequest(0x5b, 80);
}


void my_setup_2() {
    ledRed(false);
    ledGreen(true);

    schAdd(helloWorld, NULL, 0, 5000);
    schAdd(helloMeterbus, NULL, 0, 10000);

}

void my_loop() {
    schExec();
}

void SYSTICK_Callback() {
    schUpdate();
}

void HAL_GPIO_EXTI_Callback(uint16_t pin) {
    if (pin == Loop_Status_Pin) {
        loopStatusCallback();
    }
}